JUCE: dsp::LookupTable< FloatType > Class Template Reference

JUCE

Public Member Functions | List of all members
dsp::LookupTable< FloatType > Class Template Reference
juce_dsp » maths

Class for efficiently approximating expensive arithmetic operations. More...

`#include <juce_LookupTable.h>`

## Public Member Functions
| LookupTable ()
| Creates an uninitialised LookupTable object. More...
| LookupTable (const std::function< FloatType(size_t)> &functionToApproximate, size_t numPointsToUse)
| Creates and initialises a LookupTable object. More...
void | initialise (const std::function< FloatType(size_t)> &functionToApproximate, size_t numPointsToUse)
| Initialises or changes the parameters of a LookupTable object. More...
FloatType | getUnchecked (FloatType index) const noexcept
| Calculates the approximated value for the given index without range checking. More...
FloatType | get (FloatType index) const noexcept
| Calculates the approximated value for the given index with range checking. More...
FloatType | operator[] (FloatType index) const noexcept
size_t | getNumPoints () const noexcept
| Returns the size of the LookupTable, i.e., the number of pre-calculated data points. More...
bool | isInitialised () const noexcept
| Returns true if the LookupTable is initialised and ready to be used. More...

## Detailed Description

template<typename FloatType>
class dsp::LookupTable< FloatType >

Class for efficiently approximating expensive arithmetic operations.

The approximation is based on linear interpolation between pre-calculated values. The approximated function should be passed as a callable object to the constructor along with the number of data points to be pre-calculated. The accuracy of the approximation can be increased by using more points at the cost of a larger memory footprint.

Consider using LookupTableTransform as an easy-to-use alternative.

Example:

    LookupTable<float> lut ([] (size_t i) { return std::sqrt ((float) i); }, 64);
    auto outValue = lut[17];

See also
  LookupTableTransform

## Constructor & Destructor Documentation

## ◆ LookupTable() [1/2]

template<typename FloatType >

dsp::LookupTable< FloatType >::LookupTable | ( |  | ) |

Creates an uninitialised LookupTable object.

You need to call initialise() before using the object. Prefer using the non-default constructor instead.

See also
  initialise

## ◆ LookupTable() [2/2]

template<typename FloatType >

dsp::LookupTable< FloatType >::LookupTable | ( | const std::function< FloatType(size_t)> & | functionToApproximate,
|  | size_t | numPointsToUse
| ) |  |

Creates and initialises a LookupTable object.

Parameters

  functionToApproximate | The function to be approximated. This should be a mapping from the integer range [0, numPointsToUse - 1].
  numPointsToUse | The number of pre-calculated values stored.

## Member Function Documentation

## ◆ initialise()

template<typename FloatType >

void dsp::LookupTable< FloatType >::initialise | ( | const std::function< FloatType(size_t)> & | functionToApproximate,
|  | size_t | numPointsToUse
| ) |  |

Initialises or changes the parameters of a LookupTable object.

This function can be used to change what function is approximated by an already constructed LookupTable along with the number of data points used. If the function to be approximated won't ever change, prefer using the non-default constructor.

Parameters

  functionToApproximate | The function to be approximated. This should be a mapping from the integer range [0, numPointsToUse - 1].
  numPointsToUse | The number of pre-calculated values stored.

## ◆ getUnchecked()

template<typename FloatType >

FloatType dsp::LookupTable< FloatType >::getUnchecked | ( | FloatType | index | ) | const
| noexcept

Calculates the approximated value for the given index without range checking.

Use this if you can guarantee that the index is non-negative and less than numPoints. Otherwise use get().

Parameters

  index | The approximation is calculated for this non-integer index.

Returns
  The approximated value at the given index.

See also
  get, operator[]

References gl::f, dsp::LookupTable< FloatType >::getNumPoints(), gl::index, dsp::LookupTable< FloatType >::isInitialised(), isPositiveAndBelow(), jassert, jmap(), truncatePositiveToUnsignedInt(), gl::x0, and gl::x1.

Referenced by dsp::LookupTable< FloatType >::get(), and dsp::LookupTable< FloatType >::operator[]().

## ◆ get()

template<typename FloatType >

FloatType dsp::LookupTable< FloatType >::get | ( | FloatType | index | ) | const
| noexcept

Calculates the approximated value for the given index with range checking.

This can be called with any input indices. If the provided index is out-of-range either the bottom or the top element of the LookupTable is returned.

If the index is guaranteed to be in range use the faster getUnchecked() instead.

Parameters

  index | The approximation is calculated for this non-integer index.

Returns
  The approximated value at the given index.

See also
  getUnchecked, operator[]

References dsp::LookupTable< FloatType >::getNumPoints(), dsp::LookupTable< FloatType >::getUnchecked(), and gl::index.

## ◆ operator[]()

template<typename FloatType >

FloatType dsp::LookupTable< FloatType >::operator[] | ( | FloatType | index | ) | const
| noexcept

See also
  getUnchecked

References dsp::LookupTable< FloatType >::getUnchecked(), and gl::index.

## ◆ getNumPoints()

template<typename FloatType >

size_t dsp::LookupTable< FloatType >::getNumPoints | ( |  | ) | const
| noexcept

Returns the size of the LookupTable, i.e., the number of pre-calculated data points.

Referenced by dsp::LookupTable< FloatType >::get(), and dsp::LookupTable< FloatType >::getUnchecked().

## ◆ isInitialised()

template<typename FloatType >

bool dsp::LookupTable< FloatType >::isInitialised | ( |  | ) | const
| noexcept

Returns true if the LookupTable is initialised and ready to be used.

Referenced by dsp::LookupTable< FloatType >::getUnchecked().

The documentation for this class was generated from the following file:

- juce_LookupTable.h